# TPK4186 - Advanced Tools for Performance Engineering
# AlphabetInc.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.


import matplotlib.pyplot as plt
import matplotlib.dates as dts
import datetime

#dates = [10-03-2016, 10-04-2016, 10-05-2016, 10-06-2016, 10-07-2016]

date03 = datetime.date(2016, 10, 3)
date07 = datetime.date(2016, 10, 8)
delta  = datetime.timedelta(days=1)
dates  = dts.drange(date03, date07, delta)

yOpen  = [774.2, 776.030029, 779.309998, 779, 779.659973]
yHigh  = [776.065002, 778.710022, 782.070007, 780.47998, 779.659973]
yLow   = [769.5, 772.890015, 775.650024, 775.539978, 770.75]
yClose = [772.559998, 776.429993,776.469971, 776.859985, 775.080017]

formatter = dts.DateFormatter('%m/%d/%y')
fig, ax = plt.subplots()
plt.plot_date(dates, yOpen, 'g-', label='Open')
plt.plot_date(dates, yHigh, 'y-', label='High')
plt.plot_date(dates, yLow, 'r-', label='Low')
plt.plot_date(dates, yClose, 'b-', label='Close')
ax.xaxis.set_major_formatter(formatter)
plt.xticks(rotation=30)

plt.title('Financial Data Alphabet Inc.')
plt.ylabel('Value')
plt.xlabel('Date')
plt.legend()
plt.savefig('AlphabetInc.pdf')  
plt.show()
plt.close()