# TPK4186 - Advanced Tools for Performance Engineering
# IndefiniteIntegral.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import math
import numpy as np
import matplotlib.pyplot as plt

# Q1

def f(x):
  return math.exp(-x)/(1+(x-1)**2)

n = 100
max = 10
dx = max/n
Xs = np.zeros(n)
Ys = np.zeros(n)
x = 0
for i in range(0, n):
  Xs[i] = x
  Ys[i] = f(x)
  x += dx

plt.plot(Xs, Ys)
plt.show()

# Q2
def G(z, n):
  dx = z/n
  x = 0
  sum = 0.0
  for i in range(0, n):
    sum += f(x)
    x += dx
  return sum/n

n = 1000
z = 4
print(str(n) + "\t" + str(z) + "\t" + str(G(z, n)))
n = 10000
z = 4
print(str(n) + "\t" + str(z) + "\t" + str(G(z, n)))
n = 100000
z = 4
print(str(n) + "\t" + str(z) + "\t" + str(G(z, n)))
n = 1000000
z = 4
print(str(n) + "\t" + str(z) + "\t" + str(G(z, n)))

# Q3
def H(z, x, n):
  dx = (x - z)/n
  y = z
  sum = 0.0
  n = 0
  while y<=x:
    sum += f(x)
    y += dx
    n += 1
  return sum/n

x = 10
n = 1000
print(str(x) + "\t" + str(dx) + "\t" + str(H(z, x, n)))
   
  
