# TPK4186 - Advanced Tools for Performance Engineering
# MatrixEquation1.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import math
from Matrices import *

# Definition of matrices A, B and C
A = [
  [1, 0, -1, 2],
  [0, 3, 1, -1],
  [2, 4, 0, 3],
  [-3, 1, -1, 2]]
B = [
 [1, 2],
 [3, -1],
 [0, -2],
 [4, 1]]
C = [
  [3, -2, 0, 5],
  [1, 0, -3, 4]]

print("A =")
MatrixPrint(A)
print("")
print("B =")
MatrixPrint(B)
print("")
print("C =")
MatrixPrint(C)
print("")

# Calculation of matrix M

D = MatrixPower(A, 3)
E = MatrixMultiplyByScalar(D, 3)
F = MatrixProduct(B, C)
G = MatrixPower(F, 2)
H = MatrixMultiplyByScalar(G, -5)
X = MatrixSum(E, H)

print("X =")
MatrixPrint(X)
print("")

