# TPK4186 - Advanced Tools for Performance Engineering
# NumpyBasics.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import numpy as np

# Q1
A = np.arange(9) + 2
B = A.reshape((3, 3))
print("Q1:")
print(B)
print()

# Q2
A = np.arange(9).reshape((3, 3))
B = np.flip(A, 0)
C = np.flip(B, 1)
print("Q2:")
print(B)
print(C)
print()

# Q3
A = np.zeros(64).reshape((8, 8))
A[0::2, 1::2] = 1
A[1::2, 0::2] = 1
print("Q3:")
print(A)
print()

# Q4
C = np.arange(-10, 30, 5)
F = (C * 9) / 5 + 32
D = ((F - 32) * 5) / 9
print("Q4:")
print(C)
print(F)
print(D)
print()

# Q5
def SwapColumns(M, i, j):
  C = np.copy(M[:, i])
  M[:, i] = M[: ,j]
  M[:, j] = C

def SwapRows(M, i, j):
  R = np.copy(M[i, :])
  M[i, :] = M[j, :]
  M[j, :] = R

M = np.arange(20).reshape((4, 5))
print("Q5:")
print(M)
SwapColumns(M, 1, 3)
print(M)
SwapRows(M, 1, 3)
print(M)
print()

